//
//  VerjaardagenTableViewController.swift
//  BirthdayTracker
//
//  Created by Gloria Winquist on 01-11-17.
//  Copyright © 2017 iOS Kids. All rights reserved.
//

import UIKit

protocol VerjaardagToevoegenViewControllerDelegate {
    
    func verjaardagToevoegenViewController(_verjaardagToevoegenViewController: VerjaardagToevoegenViewController, didVerjaardagToevoegen verjaardag: Verjaardag)
}

class VerjaardagenTableViewController: UITableViewController, VerjaardagToevoegenViewControllerDelegate {
    
    var verjaardagen = [Verjaardag]()
    
    let dateFormatter = DateFormatter()

    override func viewDidLoad() {
        super.viewDidLoad()
        
        dateFormatter.dateStyle = .full
        dateFormatter.timeStyle = .none
    }

    // MARK: - Table view data source

    override func numberOfSections(in tableView: UITableView) -> Int {
        // #warning Incomplete implementation, return the number of sections
        return 1
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        // #warning Incomplete implementation, return the number of rows
        return verjaardagen.count
    }

    
    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "verjaardagCellIdentifier", for: indexPath)

        let verjaardag = verjaardagen[indexPath.row]
        
        cell.textLabel?.text = verjaardag.voornaam + " " + verjaardag.achternaam
        
        cell.detailTextLabel?.text = dateFormatter.string(from: verjaardag.geboortedatum)

        return cell
    }

    /*
    // Override to support conditional editing of the table view.
    override func tableView(_ tableView: UITableView, canEditRowAt indexPath: IndexPath) -> Bool {
        // Return false if you do not want the specified item to be editable.
        return true
    }
    */

    /*
    // Override to support editing the table view.
    override func tableView(_ tableView: UITableView, commit editingStyle: UITableViewCellEditingStyle, forRowAt indexPath: IndexPath) {
        if editingStyle == .delete {
            // Delete the row from the data source
            tableView.deleteRows(at: [indexPath], with: .fade)
        } else if editingStyle == .insert {
            // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
        }    
    }
    */

    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destinationViewController.
     let navigationController = segue.destination as! UINavigationController
        let verjaardagToevoegenViewController = navigationController.topViewController as! VerjaardagToevoegenViewController
        verjaardagToevoegenViewController.delegate = self
        
        // Pass the selected object to the new view controller.
    }
    
    //MARK: - VerjaardagToevoegenViewControllerDelegate
    
    func verjaardagToevoegenViewController(_verjaardagToevoegenViewController _verjaadagToevoegenViewController: VerjaardagToevoegenViewController, didVerjaardagToevoegen verjaardag: Verjaardag) {
        
        verjaardagen.append(verjaardag)
        tableView.reloadData()
    }
}
