//
//  ViewController.swift
//  BirthdayTracker
//
//  Created by Gloria Winquist on 4/10/17.
//  Copyright © 2017 iOS Kids. All rights reserved.
//

import UIKit
import CoreData
import UserNotifications

class VerjaardagToevoegenViewController: UIViewController {

    @IBOutlet var voornaamTextField: UITextField!
    @IBOutlet var achternaamTextField: UITextField!
    @IBOutlet var geboortedatumPicker: UIDatePicker!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        geboortedatumPicker.maximumDate = Date()
    }

    @IBAction func opslaanGetikt(_ sender: UIBarButtonItem) {
        
        print("Op de knop Opslaan is getikt.")
        
        let voornaam = voornaamTextField.text ?? ""
        let achternaam = achternaamTextField.text ?? ""
        let geboortedatum = geboortedatumPicker.date
        
        let appDelegate = UIApplication.shared.delegate as! AppDelegate
        let context = appDelegate.persistentContainer.viewContext

        let nieuweVerjaardag = Verjaardag(context: context)
        nieuweVerjaardag.voornaam = voornaam
        nieuweVerjaardag.achternaam = achternaam
        nieuweVerjaardag.geboortedatum = geboortedatum as NSDate?
        nieuweVerjaardag.verjaardagId = UUID().uuidString
        if let uniqueId = nieuweVerjaardag.verjaardagId {
            print("Het verjaardagId is \(uniqueId)")
        }

        do {
            try context.save()
            let message = "Wens \(voornaam) \(achternaam) een fijne verjaardag!"
            let content = UNMutableNotificationContent()
            content.body = message
            content.sound = UNNotificationSound.default()
            var dateComponents = Calendar.current.dateComponents([.month, .day], from: geboortedatum)
            dateComponents.hour = 8
            let trigger = UNCalendarNotificationTrigger(dateMatching: dateComponents, repeats: true)
            if let identifier = nieuweVerjaardag.verjaardagId {
                
                let request = UNNotificationRequest(identifier: identifier, content: content, trigger: trigger)
                let center = UNUserNotificationCenter.current()
                center.add(request, withCompletionHandler: nil)
            }
        } catch let error {
            print("Kan niet opslaan door \(error).")
        }
        
        dismiss(animated: true, completion: nil)
    }
    
    @IBAction func annulerenGetikt(_ sender: UIBarButtonItem) {
        dismiss(animated: true, completion: nil)
    }

}

