//: Playground - noun: a place where people can play

// Programmeer je eigen iPhone en iPad apps
// Hoofdstuk 8 Examples

// Class overerving

// Een superclass maken

class Boerderijdier {
    
    var naam = "boerderijdier"
    var aantalPoten = 4
    func zegHallo() -> String {
        return "Hallo, ik ben een boerderijdier!"
    }
    func beschrijving() {
        print("Ik ben een \(naam) en ik heb \(aantalPoten) poten.")
    }
}

// Een subclass maken

class Schaap: Boerderijdier {
    
    override init() {
        super.init()
        naam = "schaap"
    }
    
    override func zegHallo() -> String {
        return "beh"
    }
    
    override func beschrijving() {
        super.beschrijving()
        print("Ik zorg voor wol om dekens mee te maken.")
    }
}

let eenSchaap = Schaap()
eenSchaap.zegHallo()
eenSchaap.beschrijving()

class Varken: Boerderijdier {
    
    override init() {
        super.init()
        naam = "varken"
        aantalPoten = 4
    }
    
    override func zegHallo() -> String {
        return "knor knor"
    }
    
    override func beschrijving() {
        super.beschrijving()
        print("Ik rol in de modder.")
    }
}

// Het datatype detecteren door typecasten

class Kip: Boerderijdier {
    
    var aantalEieren = 0
    
    override init() {
        super.init()
        naam = "kip"
        aantalPoten = 2
    }
    
    override func zegHallo() -> String {
        return "tok tok"
    }
    
    override func beschrijving() {
        super.beschrijving()
        print("Ik leg eieren.")
        if aantalEieren == 1 {
            print("Ik heb een ei voor je.")
        } else if aantalEieren > 0 {
            print("Ik heb \(aantalEieren) eieren voor je.")
        }
    }
    
    func legEenEi() {
        aantalEieren += 1
    }
    
    func geefDeEieren() -> Int {
        let eieren = aantalEieren
        aantalEieren = 0
        return eieren
    }
}

let kip1 = Kip()
kip1.legEenEi()
let kip2 = Kip()
kip2.legEenEi()
kip2.legEenEi()

let dieren = [Schaap(), kip1, kip2, Schaap(), Kip(), Schaap(), Varken()]

for dier in dieren {

    if dier is Schaap {
        print("Dit zegt mijn schaap: \(dier.zegHallo())")
    } else if dier is Kip {
    
        print("Mijn kippen zeggen: \(dier.zegHallo())")
        
        //dier.legEenEi() // Foutmelding Boerderijdier has no member legEenEi
        
        let kip = dier as! Kip
        kip.legEenEi()
        kip.beschrijving()
        
    } else if dier is Varken {
        print("En mijn varken zegt: \(dier.zegHallo())")
    }
}

// Het datatype verfijnen door downcasten

var verzameldeEieren = 0
for dier in dieren {
    
    if let kip = dier as? Kip {
        
        kip.legEenEi()
        print("Ik pak \(kip.aantalEieren) eieren.")
        verzameldeEieren += kip.geefDeEieren()
    }
}
print("Ik heb vandaag \(verzameldeEieren) eieren verzameld!")



